/*
 * Original code done by Phate6660.
 * Released under public domain.
 *
 * Modifications done for Hyperbola.
 * Copyright (c) 2025 Hyperbola Project
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <fstream>
#include <vector>
#include "../helpers/functions.hpp"

std::string uptime() {
    std::ifstream uptime_file("/proc/uptime"); // Open the file for reading.
    std::string line,uptime_pre_calculation;
    int uptime;
    uptime_pre_calculation.assign(
                                  (std::istreambuf_iterator<char>(uptime_file)),
                                  (std::istreambuf_iterator<char>())
                                  );
    uptime_file.close(); // Close the file.
    // Create the vector from the string with the delimiter.
    std::vector<std::string> result = explode(uptime_pre_calculation, ' ');
    result = explode(result[0], '.');
    uptime = std::stoi(result[0]);
    if (uptime > 86400) {
        int days = uptime / 60 / 60 / 24;
        int hours = (uptime / 60 / 60) % 24;
        int minutes = (uptime / 60) % 60;
        std::string output = std::to_string(days) + "d "
            + std::to_string(hours) + "h "
            + std::to_string(minutes) + "m";
        return output;
    } else if (uptime > 3600) {
        int hours = (uptime / 60 / 60) % 24;
        int minutes = (uptime / 60) % 60;
        std::string output = std::to_string(hours) + "h "
            + std::to_string(minutes) + "m";
        return output;
    } else if (uptime > 60) {
        int minutes = (uptime / 60) % 60;
        return std::to_string(minutes) + "m";
    } else {
	return "<1m";
    }
}
